;;
;; GgrTF::HitStats - Weapon hit statistics
;; (C) Copyright 2008-2009 Matti Hmlinen (Ggr)
;;
;; This file (triggerset) is Free Software distributed under
;; GNU General Public License version 2.
;;
;; NOTICE! This file requires GgrTF (version 0.6.9 or later) to be loaded.
;;
/loaded GgrTF::HitStats
/set gmodule=HitStats

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Hit stats
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
/set hst_types=axes bluds poles
/prdefsetting -n"mhits" -d"Mangle YOUR hit messages" -s"off gag short"
/eval /prdefsetting -n"weapon1" -d"Wielded weapon #1 type for hitstats" -s"none %{hst_types}"
/eval /prdefsetting -n"weapon2" -d"Wielded weapon #2 type for hitstats" -s"none %{hst_types}"


;; Gag something according to stats
/def -i prset =\
	/eval /if (%{1}=~"") /set %{1}=%{2}%%;/endif

/def -i ghitstats_gag =\
	/if (set_mhits=~"gag") \
		/substitute -ag%;\
	/elseif (set_mhits=~"short") \
		/substitute -ag%;\
		/set hst_short=%{hst_short} %{1},%;\
	/endif

/def -i ghitstats_mangle =\
	/if (set_mhits=~"short" & hst_short!~"")\
		/let _htmp=$[substr(hst_short,1,-1)]%;\
		/echo -p @{BCwhite}You %{_htmp}.@{n}%;\
		/set hst_short=%;\
	/endif


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Initialization
/def -i ghitstats_init_do =\
	/while ({#})\
		/set lst_%{1}_hits=%;\
		/shift%;\
	/done

/def -i ghitstats_init =\
	/prset set_mhits off%;\
	/prset set_weapon1 none%;\
	/prset set_weapon2 none%;\
	/set lst_special=%;\
	/set hst_crithit=0%;\
	/set lst_special=%;\
	/test prlist_insert("event_battle_round", "ghitstats_mangle")%;\
	/ghitstats_init_do %{hst_types}

/ghitstats_init


;; Reset the statistics
/def -i ghitstats_reset_special =\
	/while ({#})\
		/set hst_%{1}=0%;\
		/shift%;\
	/done

/def -i ghitstats_reset_do =\
	/let _hname=%{1}%;/shift%;\
	/while ({#})\
		/set hst_%{_hname}_%{1}=0%;\
		/set hst_c%{_hname}_%{1}=0%;\
		/shift%;\
	/done

/def -i ghitstats_reset =\
	/while ({#})\
		/set hst_%{1}_total=0%;\
		/set hst_%{1}_crits=0%;\
		/eval /ghitstats_reset_do %{1} %%{lst_%{1}_hits}%;\
		/shift%;\
	/done

/def -i hstreset =\
	/msq @{BCgreen}Resetting hit statistics!@{n}%;\
	/set hst_special=0%;\
	/ghitstats_reset %{hst_types}%;\
	/ghitstats_reset_special %{lst_special}



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
/def -i prgetshort =\
	/let _tpos=$[strchr({1}," ")]%;\
	/if (_tpos >= 0)\
		/return strcat(substr({1},0,3),"_",substr({1},_tpos+1))%;\
	/else \
		/return {1}%;\
	/endif


;; Define a special message (for misses, parries, etc.)
/def -i prdefhitspec =\
	/if (!getopts("s:n:t:r", "")) /gerror Invalid prdefhitspec definition!%;/break%;/endif%;\
	/if (opt_s=~""|opt_n=~""|opt_t=~"") /gerror Required arguments not specified!%;/break%;/endif%;\
	/if (opt_r) /let _ttype=regexp%;/else /let _ttype=simple%;/endif%;\
	/test prlist_insert("lst_special", opt_n)%;\
	/def -i -p99999 -F -m%{_ttype} -t"%{opt_t}" ghitstats_%{opt_n} =\
		/ghitstats_gag %{opt_s}%%;\
		/set hst_special=$$[hst_special+1]%%;\
		/set hst_%{opt_n}=$$[hst_%{opt_n}+1]


;; Detect critical hits
/def -i -mregexp -t"^You score a \*?CRITICAL\*? hit!$" ghitstats_crit =\
	/set hst_crithit=1

;; Define a hit message
/def -i prdefhit =\
	/let _hname=%{1}_%{2}%;\
	/let _yname=$[prgetshort({3})]%;\
	/test prlist_insert("lst_%{1}_hits", {2})%;\
	/set hst_name_%{_hname}=%{3}%;\
	/def -i -p99999 -F -mregexp -t"^(You|(Cackling|Smiling|Grinning) (demonically|devilishly|diabolically) you) %{3} " ghitstats_%{_hname} =\
		/ghitstats_gag %{_yname}%%;\
		/set hst_%{1}_total=$$[hst_%{1}_total+1]%%;\
		/if (hst_crithit==1) \
			/set hst_%{1}_crits=$$[hst_%{1}_crits+1]%%;\
			/set hst_c%{_hname}=$$[hst_c%{_hname}+1]%%;\
		/else \
			/set hst_%{_hname}=$$[hst_%{_hname}+1]%%;\
		/endif%%;\
		/set hst_crithit=0


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Specials
/prdefhitspec -n"misses" -t"^You miss(\.$| )" -r -s"miss"
/prdefhitspec -n"dodges" -t"^You (successfully dodge |dodge\.$)" -r -s"dodge"
/prdefhitspec -n"parries" -t"You parry." -s"parry"
/prdefhitspec -n"ripostes" -t"...AND riposte." -s"riposte"
/prdefhitspec -n"tumbles" -t"^You tumble .+'s dodge.$" -r -s"tumble"
/prdefhitspec -n"stuns" -t"^You STUN |WHO avoids being stunned with" -r -s"STUN"
/prdefhitspec -n"stunmanos" -t"^LAA LAALIS PASKI ASTUSTA TULLUT ROU" -r -s"stunmano"


;; Non-weapon
/set hst_name_brawl=Brawling
/test prdefhit("brawl", 01, "spank")
/test prdefhit("brawl", 02, "smack")


;; Polearms
/set hst_name_poles=Polearms
/test prdefhit("poles", 01, "scratch")
/test prdefhit("poles", 02, "slightly pierce")
/test prdefhit("poles", 03, "pierce")
/test prdefhit("poles", 04, "puncture")
/test prdefhit("poles", 05, "sink")
/test prdefhit("poles", 06, "bore")
/test prdefhit("poles", 07, "crater")
/test prdefhit("poles", 08, "cavitate")
/test prdefhit("poles", 09, "shaft")
/test prdefhit("poles", 10, "gorge")
/test prdefhit("poles", 11, "really poke")
/test prdefhit("poles", 12, "riddle")
/test prdefhit("poles", 13, "dig into")
/test prdefhit("poles", 14, "dig through")
/test prdefhit("poles", 15, "chasm")
/test prdefhit("poles", 16, "drill")
/test prdefhit("poles", 17, "powerfully perforate")
/test prdefhit("poles", 18, "powerfully pierce")
/test prdefhit("poles", 19, "cruelly crater")
/test prdefhit("poles", 20, "savagely shaft")
/test prdefhit("poles", 21, "uncontrollably dig")
/test prdefhit("poles", 22, "REALLY DRILL")
/test prdefhit("poles", 23, "CRUELLY RIDDLE")
/test prdefhit("poles", 24, "BRUTALLY BORE")
/test prdefhit("poles", 25, "BARBARICALLY PIERCE")


;; Slashing weapons (axes and long blades)
/set hst_name_axes=Axes/Long blades
/test prdefhit("axes", 01, "solidly slash")
/test prdefhit("axes", 02, "gash")
/test prdefhit("axes", 03, "lightly cut")
/test prdefhit("axes", 04, "cut")
/test prdefhit("axes", 05, "tear")
/test prdefhit("axes", 06, "incise")
/test prdefhit("axes", 07, "shred")
/test prdefhit("axes", 08, "horribly shred")
/test prdefhit("axes", 09, "slash")
/test prdefhit("axes", 10, "incisively cut")
/test prdefhit("axes", 11, "pierce")
/test prdefhit("axes", 12, "slit")
/test prdefhit("axes", 13, "cruelly tatter")
/test prdefhit("axes", 14, "rive")
/test prdefhit("axes", 15, "savagely shave")
/test prdefhit("axes", 16, "cruelly slash")
/test prdefhit("axes", 17, "uncontrollably slash")
/test prdefhit("axes", 18, "quickly cut")
/test prdefhit("axes", 19, "savagely rip")
/test prdefhit("axes", 20, "BRUTALLY TEAR")
/test prdefhit("axes", 21, "SAVAGELY SHRED")
/test prdefhit("axes", 22, "CRUELLY REND")
/test prdefhit("axes", 23, "DISMEMBER")


;; Bludgeons
/set hst_name_bluds=Bludgeons
/test prdefhit("bluds", 01, "jostle")
/test prdefhit("bluds", 02, "butt")
/test prdefhit("bluds", 03, "bump")
/test prdefhit("bluds", 04, "thump")
/test prdefhit("bluds", 05, "stroke")
/test prdefhit("bluds", 06, "thrust")
/test prdefhit("bluds", 07, "jab")
/test prdefhit("bluds", 08, "bash")
/test prdefhit("bluds", 09, "strike")
/test prdefhit("bluds", 10, "sock")
/test prdefhit("bluds", 11, "cuff")
/test prdefhit("bluds", 12, "knock")
/test prdefhit("bluds", 13, "flail")
/test prdefhit("bluds", 14, "whack")
/test prdefhit("bluds", 15, "beat")
/test prdefhit("bluds", 16, "smash")
/test prdefhit("bluds", 17, "cruelly beat")
/test prdefhit("bluds", 18, "badly smash")
/test prdefhit("bluds", 19, "horribly thrust")
/test prdefhit("bluds", 20, "savagely sock")
/test prdefhit("bluds", 21, "savagely strike")
/test prdefhit("bluds", 22, "REALLY WHACK")
/test prdefhit("bluds", 23, "BRUTALLY BEAT")
/test prdefhit("bluds", 24, "CRUELLY CUFF")
/test prdefhit("bluds", 25, "BARBARICALLY BASH")


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Helpers
/def -i gline_add =\
	/eval /set hst_str_%{hst_line}=%%{hst_str_%{hst_line}}%{1}%;\
	/set hst_line=$[hst_line+1]

/def -i gline_clear =\
	/let _line=0%;\
	/while (_line <= {1})\
		/eval /unset hst_str_%{_line}%;\
		/let _line=$[_line+1]%;\
	/done

/def -i gline_print =\
	/let _line=1%;\
	/while (_line <= {1})\
		/eval /set _line_s=$$[hst_str_%{_line}]%;\
		/if (_line_s!~"") /msw %{_line_s}|%;/endif%;\
		/let _line=$[_line+1]%;\
	/done


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Output
/def -i ghitstats_print =\
/let _nlines=%{3}%;\
/eval /set _hst_name=$$[hst_name_%{1}_%{2}]%;\
/eval /set _hst_hits=$$[hst_%{1}_%{2}]%;\
/eval /set _hst_crits=$$[hst_c%{1}_%{2}]%;\
/if (_hst_hits > 0 | _hst_crits > 0)\
	/if (hst_noprint==1)\
		/set hst_total=$[hst_total + _hst_hits]%;\
		/set hst_crits=$[hst_crits + _hst_crits]%;\
		/set hst_count=$[hst_count + 1]%;\
		/set hst_line=$[hst_line+1]%;\
	/else \
/if (hst_total > 0) /let _htmp=$[trunc((100 * _hst_hits) / hst_total)]%;/else /let _htmp=0%;/endif%;\
/if (hst_crits > 0) /let _ctmp=$[trunc((100 * _hst_crits) / hst_crits)]%;/else /let _ctmp=0%;/endif%;\
/test gline_add("|$[pad(substr(_hst_name,0,20),-20)]: @{Cgreen}$[pad(_hst_hits, 6)]@{n} (@{BCgreen}$[pad(_htmp,3)]\\%@{n}):@{Cred}$[pad(_hst_crits, 6)]@{n} (@{BCred}$[pad(_ctmp,3)]\\%@{n})")%;\
	/endif%;\
/else \
	/if (hst_noprint==0 & hst_line >= _nlines)\
		/test gline_add("|                                               ")%;\
	/endif%;\
/endif


/def -i ghitstats_dolist =\
	/let _thn=%{1}%;/shift%;\
	/let _thc=%{1}%;/shift%;\
	/while ({#}) /test ghitstats_print(_thn,{1},_thc)%;/shift%;/done

/def -i ghitstats_list =\
/set hst_column=$[hst_column+1]%;\
/set hst_line=0%;\
/test gline_add("-----------------------------------------------")%;\
/eval /set _hst_name=$$[hst_name_%{1}]%;\
/test gline_add("+-| @{BCgreen}$[pad(_hst_name,-20)]@{n} |----------------------")%;\
/eval /ghitstats_dolist %{1} %%{hst_nlines%{hst_column}} %%{lst_%{2}_hits}



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
/def -i hstats =\
/set hst_count=0%;\
/set hst_total=0%;\
/set hst_crits=0%;\
/set hst_noprint=1%;\
/set hst_column=0%;\
/if (set_weapon1!~"none") /ghitstats_list %{set_weapon1} %{set_weapon1}%;/endif%;\
/set hst_nlines1=%{hst_line}%;\
/if (set_weapon2!~"none") /ghitstats_list %{set_weapon2} %{set_weapon2}%;/endif%;\
/set hst_nlines2=%{hst_line}%;\
/if (hst_nlines1 >= hst_nlines2)\
	/set hst_nlines=%{hst_nlines1}%;\
	/set hst_list=%{set_weapon1}%;\
/else \
	/set hst_nlines=%{hst_nlines2}%;\
	/set hst_list=%{set_weapon2}%;\
/endif%;\
/set hst_noprint=0%;\
/set hst_column=0%;\
/gline_clear %{hst_nlines}%;\
/msw ,----------------------.%;\
/msw | @{BCgreen}GgrTF@{n} @{Cyellow}Hit Statistics@{n} |%;\
/if (set_weapon1!~"none") /ghitstats_list %{set_weapon1} %{hst_list}%;/endif%;\
/if (set_weapon2!~"none") /set hst_str_0=%{hst_str_0}-%;/ghitstats_list %{set_weapon2} %{hst_list}%;/endif%;\
/if (hst_str_0!~"") /msw +%{hst_str_0}.%;/endif%;\
/gline_print $[hst_nlines]%;\
/if (hst_str_0!~"") /msw +%{hst_str_0}'%;/endif%;\
/gline_clear %{hst_nlines}%;\
/msw +-| @{BCred}Totals@{n} |-------------------------------------------+%;\
/let _qtmp=$[hst_total + hst_misses]%;\
/if (_qtmp != 0) \
	/let _qtmp1=$[trunc((100 * hst_total) / _qtmp)]%;\
	/let _qtmp2=$[trunc((100 * hst_misses) / _qtmp)]%;\
	/let _qtmp3=$[trunc((100 * hst_crits)  / _qtmp)]%;\
/else \
	/let _qtmp1=0%;\
	/let _qtmp2=0%;\
	/let _qtmp3=0%;\
/endif%;\
/msw | Hits..: @{Cgreen}$[pad(hst_total,-10)]@{n} (@{BCgreen}$[pad(_qtmp1,3)]\%@{n}) | Crits: @{Cred}$[pad(hst_crits,-10)]@{n} (@{BCred}$[pad(_qtmp3,3)]\%@{n}) |%;\
/msw | Misses: @{Cyellow}$[pad(hst_misses,-10)]@{n} (@{BCyellow}$[pad(_qtmp2,3)]\%@{n}) | Total hit types: @{BCwhite}$[pad(hst_count,-7)]@{n} |%;\
/msw +----------------------------------------------+-------'%;\
/msw | Dodges..: @{BCmagenta}$[pad(hst_dodges,-10)]@{n} | Parries..: @{BCyellow}$[pad(hst_parries,-10)]@{n} |%;\
/msw | Tumbles.: @{BCgreen}$[pad(hst_tumbles, -10)]@{n} | Stuns....: @{BCred}$[pad(hst_stuns,-10)]@{n} |%;\
/msw | Ripostes: @{BCgreen}$[pad(hst_ripostes,-10)]@{n} | Stun mano: @{BCred}$[pad(hst_stunmanos,-10)]@{n} |%;\
/msw `----------------------------------------------'


